\documentclass[pdf,xcolor=dvipsnames]{beamer}

\usepackage{multicol}
%\usepackage{lipsum}
\usepackage{amsmath}
\usepackage{relsize}%

\usepackage{graphicx}
\graphicspath{{./img/}}
\DeclareGraphicsExtensions{.jpeg,.pdf,.png,.svg,.jpg}


\definecolor{UMblue}{RGB}{20,40,75}
\definecolor{UMred}{RGB}{203,32,46}

\usetheme{CambridgeUS}
\useinnertheme{circles}

%\setbeamercolor{palette primary}{bg=UMblue,fg=white}
\setbeamercolor{palette secondary}{bg=UMred,fg=white}
\setbeamercolor{palette tertiary}{bg=UMblue,fg=white}
%\setbeamercolor{palette quaternary}{bg=UMblue,fg=white}
%\setbeamercolor{pallete sidebar primary}{fg=blue}
%\setbeamercolor{pallete sidebar secondary}{red}
\setbeamercolor{structure}{fg=UMblue} % itemize, enumerate, etc
\setbeamercolor{section in toc}{fg=black!30} % TOC sections

%\usecolortheme[named=UMblue]{structure}

\setbeamercolor{normal text}{fg=white}
\setbeamercolor{titlelike}{fg=UMblue, bg=white}
\setbeamercolor{example text}{fg=white}
\setbeamercolor{background canvas}{bg=black!75}
\setbeamercolor{reversedbox}{fg=black,bg=black!10}
\usepackage{transparent}


%\mode<presentation>{}

\title[How-to Ngspice]{Simulating Circuits with Ngspice}
\subtitle{-- Nuts and Bolts --}
\author[Barry Muldrey]{
	Dr. Barry Muldrey \\
	University of Mississippi, US}

\begin{document}

\begin{frame}
	\titlepage
\end{frame}	



\section*{Outline}
\begin{frame}
	\tableofcontents
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Introduction: What is ``simulation?''}%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{System Behavior}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
	\frametitle{Making Useful Things}
	\centering
	\includegraphics[width=0.7\textwidth]{rgmachine}\\
	Overarching objective == Build something useful!
	\begin{center}
	\begin{itemize}
		\item Assemble individual components
		\item Components interact
		\item Components behave differently
		\item Components vary (manufacturing)
	\end{itemize}
	\end{center}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
	\frametitle{Predicting the Future}
	\begin{center}
		We \textit{MUST} go beyond ``trial and error'' approaches...
	\end{center}


	Pure experimentation can:
	
	\begin{columns}
		\begin{column}{0.5\textwidth}
			\begin{itemize} \small
				\item be \textbf{expensive} (semiconductor fab.)
				\item be \textbf{dangerous} (power distribution)
				\item \textbf{interfere} with others (RF transmission)
				\item \textbf{unproductive} (waiting for new PCBs)
			\end{itemize}
		\end{column}
		\begin{column}{0.5\textwidth}  %%<--- here
			\begin{center}
				\includegraphics[width=0.8\textwidth]{boomgraphic}
			\end{center}
		\end{column}
	\end{columns}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[c]
	\frametitle{System Modeling}
	
	System modeling approach:
	\begin{enumerate}
		\item Predict behavior of individual elements
		\item Capture interaction between elements \\
	\end{enumerate}
	\vskip\baselineskip
	Which should lead to:
		\begin{enumerate}  \setcounter{enumi}{2}
			\item The ability to predict \textit{system} behavior into the future
		\end{enumerate}

	\vskip1\baselineskip
	(though true for many mechanical and electrical machines, this is not \textit{generally} true!)
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[c]
	\frametitle{Graph Construction Basics}
	

	\begin{columns}
		\begin{column}{0.5\textwidth}
%			\large 
			Definitions:
			
			\begin{description} 
				\item[\colorbox{white}{\textbf{node}}] (Sub)component of the system \\
				%		\item[port] Unique pathway into or out-of a node \\
				\item[\colorbox{white}{\textbf{edge}}] Connection between two nodes \\
			\end{description}
		
			\vskip\baselineskip
		
			Connectivity Matrix: \Large %
			\begin{center}%
				\vspace{-1cm}
			\[%
			\begin{bmatrix}
				0 & 1 & 1 \\
				1 & 0 & 1 \\
				1 & 1 & 0
			\end{bmatrix}
			\]
			\end{center}
		\end{column}
	
		\begin{column}{0.5\textwidth}  %%<--- here
			\begin{center}
				\includegraphics[width=0.8\textwidth]{g4671}
			\end{center}
		\end{column}

	\end{columns}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[c]
	\frametitle{Extending Graphs to Circuits}
%	\setbeamercovered{highly dynamic}
	
	\begin{columns}
		\begin{column}{0.5\textwidth}
			%			\large 
			(Additional) Definitions:

			\begin{description}
				\onslide<1->{
					\item[\colorbox{white}{\textbf{terminal}}] electrical pathway into or out-of a node
				}
				\onslide<2->{
					\item[\colorbox{white}{\textbf{net}}] Object to intermediate edge-to-edge connections
				}
			\end{description}
		\end{column}
		
		\begin{column}{0.5\textwidth}
			\begin{center}
				\includegraphics<1>[width=0.8\textwidth]{g5137}
				\includegraphics<2>[width=0.8\textwidth]{g4991}
			\end{center}
		\end{column}
		
	\end{columns}
	
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[c]
	\frametitle{Extending Graphs to Circuits}
	%	\setbeamercovered{highly dynamic}
	
	\begin{columns}
		\begin{column}{0.5\textwidth}
			{\centering\includegraphics[width=0.8\textwidth]{g5323}}
		\end{column}
		
		\begin{column}{0.5\textwidth}
			\begin{center}

				\includegraphics[width=0.8\textwidth]{g4991}
			\end{center}
		\end{column}
		
	\end{columns}
	
\end{frame}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[c]
	\frametitle{Extending Graphs to Circuits}
	%	\setbeamercovered{highly dynamic}
	
	\begin{columns}
		\begin{column}{0.5\textwidth}
			{\centering\includegraphics[width=0.8\textwidth]{g5643}}
		\end{column}
		
		\begin{column}{0.5\textwidth}
			\begin{center}
				
				\includegraphics[width=0.8\textwidth]{g5409}
			\end{center}
		\end{column}
		
	\end{columns}
	
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[c]
	\frametitle{Extending Graphs to Circuits}
	%	\setbeamercovered{highly dynamic}
	Easier to specify making a few assumptions:
	\begin{columns}
		\begin{column}{0.5\textwidth}\noindent\small\raggedright\texttt{%
				\noindent %
					myDeviceA systemInput 2 1 \\
						\; + instanceTypeA [parameters] \\
					otherInstanceB 1 3 sysOut \\
						\; + instanceTypeB [parameters] \\
					lastOneC 2 gnd! 3 1 \\
						\; + instanceTypeC [parameters]						
					}
%			}
		\end{column}
		\begin{column}{0.5\textwidth}
			\begin{center}
				\includegraphics[width=0.8\textwidth]{g5409}
			\end{center}
		\end{column}
	\end{columns}

	
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Overview of Electrical Models}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
	\frametitle{Modeling Physical Properties}
	\begin{center}
		\includegraphics[width=0.8\textwidth]{g167895}
	\end{center}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
	\frametitle{Modeling Physical Properties}
	\begin{columns}
		\begin{column}{0.5\textwidth}
			\begin{itemize}
				\item $V_{batt} = 9$
				\item $i_d = \mathlarger{\frac{\mu C_{ox} W}{2L} \left( V_{gs} - V_t\right)^2}$\hspace{2ex}*
				\item     \[f(x) = \begin{cases} V_{SW}=0 & (V_C > 0) \\
												 I_{SW}=0 & (V_C = 0) \end{cases}\]
				\item $ I_{R} = \mathlarger{\frac{V_R}{R}} $

			\end{itemize}
		\end{column}
		\begin{column}{0.5\textwidth}  %%<--- here
			\begin{center}
				\includegraphics[width=0.9\textwidth]{g167895}
			\end{center}
		\end{column}
	\end{columns}
\end{frame}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
	\frametitle{The *Time* Dimension}
	\begin{columns}
		\begin{column}{0.5\textwidth}
			Unlike batteries, MOSFETs, resistors, diodes, BJTs, etc., capacitors and inductors' state (I,V) cannot be 
			spontaneously determined.
			\vspace{1em}
			\begin{itemize}
				\item $v_c = \mathlarger{v_{c_0} + \frac{1}{C} \int{i_c \delta t}}$
				\item $i_l = \mathlarger{i_{l_0} + \frac{1}{L} \int{v_l \delta t}}$
			\end{itemize}
			
			
		\end{column}
		\begin{column}{0.5\textwidth}  %%<--- here
			\begin{center}
				\includegraphics[width=0.9\textwidth]{g167965}
			\end{center}
		\end{column}
	\end{columns}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[c]
	\frametitle{What goes on \textit{inside} the box?}

	Spice engines contain many basic, idealized models internally:
	\footnotesize
	\hfill
	\vspace{2em}
	\begin{beamercolorbox}[rounded=true]{reversedbox}
	\begin{tabular}{lll}%
		Circuit Element & Naming Convention & Typical Parameters 			\\
		\hline
		capacitors		& \texttt{Cxxx} 	& capacitance (F)				\\
		resistors 		& \texttt{Rxxx}	& resistance ($\Omega$)			\\
		inductors 		& \texttt{Lxxx}	& inductance (H)				\\
		diodes			& \texttt{Dxxx}	& IS=saturation current (A) 	\\
		BJTs			& \texttt{Qxxx}	& BF=ideal max. forward $\beta$ 	\\
		MOSFETs			& \texttt{Mxxx}	& L=length(m), W=width(m), VTO=thresh.(v) \\
	\end{tabular}
\end{beamercolorbox}
\end{frame}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



\begin{frame}
	\frametitle{When \textit{Reality} Sets In (Nonidealities)}
	
		\begin{center}
			\includegraphics[width=0.6\textwidth]{g179896}
		\end{center}
	
\end{frame}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}
	\frametitle{``Solving'' our Models}
	\begin{center}
		\includegraphics[width=0.8\textwidth]{image172231}
	\end{center}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}
	\frametitle{Mechanizing the ``Solving''}
	\begin{center}
		\includegraphics[width=\textwidth]{g172323}
	\end{center}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Usage} %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Capturing Connectivity}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
	\frametitle{Netlists}
	\begin{center}
		\includegraphics<1>[width=0.8\textwidth]{g84782}
		\includegraphics<2>[width=0.8\textwidth]{g84771}
	\end{center}
%	\hfill
%	\begin{beamercolorbox}[rounded=true, wd=0.5\textwidth,ht=1.in,sep=1em]{reversedbox}
%		\texttt{voltage divider netlist	\\
%			V1 in 0 1 					\\
%			R1 in out 1k				\\
%			R2 out 0 2k					\\
%			.end						\\
%		}
%	\end{beamercolorbox}
%	\hfill\hfill
\end{frame}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\subsection{Interacting with the Simulator}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
	\frametitle{Interactive Invocation}
	\begin{center}
		\includegraphics[width=\textwidth]{image84792}
	\end{center}
\end{frame}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Examples}%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\end{document}